/*  ==============================================
  ==  ARDUI_PORTAIL --- 03 mars 2015 --- V 1.00   ==
 ==   Ecrit par : d.auvre (at) free (.) fr         ==
  ==  Dernière modification le : 15 février 2016  ==
    ==============================================

   * !!! ATTENTION TABULATION A 2 ESPACES !!!

*/

/*    TABLEAU TRAME   ***
 ***  Connection bluetooth page COMMANDE  ***
 * bit 0	->	S	(start)	début de trame
 * bit 1	->	C	Page active Commande
 * bit 2	->	M	Page active coMMande
 * bit 3	->	D	Page active commanDe
 * bit 4	->	E (end) fin de trame
 *
 ***  Réception d'une commande  ***
 * bit 0	->	S (start)	début de trame
 * bit 1	->	0	Mode commande
 * bit 2	->	1-Bouton portail ouverture	2-Bouton portail ouverture	3-Bouton éclairage-1	4-Bouton éclairage-2
 * bit 3	->	1-prise en compte d'une commande
 * bit 4	->	E (end)		fin de trame
 *
 ***  Réponse arduino état des commandes  ***
 * bit 0	->	S (start)	début de trame
 * bit 1	->	: Séparateur
 * bit 2	->	0	Mode commande
 * bit 3	->	: Séparateur
 * bit 4	->	1-Bouton portail ouverture	2-Bouton portail ouverture	3-Bouton éclairage-1	4-Bouton éclairage-2
 * bit 5	->	:	Séparateur
 * bit 6	->	0:OFF	1:ON 2:PRISE EN COMPTE OFF 3:PRISE EN COMPTE ON
 * bit 7	->	:	Séparateur
 * bit 8	->	E (end) fin de trame
 *
 ***********************************************************************
 *
 ***  Connection bluetooth page CONFIG ***
 * bit 0	->	S (start)	début de trame
 * bit 1	->	C	Page active Config
 * bit 2	->	O	Page active cOnfig
 * bit 3	->	N	Page active coNfig
 * bit 4	->	F	Page active conFig
 * bit 5	->	I	Page active confIg
 * bit 6	->	G	Page active confiG
 * bit 7	->	E (end) fin de trame
 *
 ***  Réception d'une config  ***
 * bit 0	->	S (start)	début de trame
 * bit 1	->	1	Mode config
 * bit 2	->	1-Bouton portail ouverture	2-Bouton portail ouverture	3-Bouton éclairage-1	4-Bouton éclairage-2
 * bit 3	->	1-Pas de tempo	2-tempo 1 seconde	3-tempo 300 secondes etc...
 * bit 4	->	1-Relais portail n°1	2-Relais portail n°2
 * bit 5	->	0	OFF	1	ON	Prise en compte eclairage 1 a l'ouverture du portail
 * bit 6	->	0	OFF	1	ON	Prise en compte eclairage 2 a l'ouverture du portail
 * bit 7	->	E (end)		fin de trame
 *
 ***  Réponse arduino état des config  ***
 * bit 0	->	S (start)	début de trame
 * bit 1	->	:	Séparateur
 * bit 2	->	1	Mode config
 * bit 3	->	: Séparateur
 * bit 4	->	1-Bouton portail ouverture	2-Bouton portail ouverture	3-Bouton éclairage-1	4-Bouton éclairage-2
 * bit 5	->	: Séparateur
 * bit 6	->	1-Pas de tempo	2-tempo 1 seconde	3-tempo 300 secondes etc...
 * bit 7	->	: Séparateur
 * bit 8	->	1-Relais portail n°1	2-Relais portail n°2
 * bit 9	->	: Séparateur
 * bit 10	->	0	OFF	1	ON	Prise en compte eclairage 1 a l'ouverture du portail
 * bit 11	->	: Séparateur
 * bit 12	->	0	OFF	1	ON	Prise en compte eclairage 2 a l'ouverture du portail
 * bit 13	->	: Séparateur
 * bit 14	->	E (end) fin de trame
*/

/***	importation des librairies	***/

#include <EEPROM.h>																											// Stockage de la configuration utilisateur
#include <SoftwareSerial.h>																							// Librairie softwareserial pour créer un uart en soft

/***	DEFINITION DES VARIABLE		***/

#define COM_Debug		Serial																							// Définition du com debug

SoftwareSerial BTSerial(10, 11);																				// Définition du com bluetooth
char BTSerial_Buffer[10] ;																							// Buffer de réception du com bluetooth
int bit = 0;																														// Compteur de bit de réception

int tempo[10] = {0,0,1,300,900,1800,2700,3600,7200,14400};							// Definition array des tempo à l'action en seconde
int rel[5]		=	{0,2,3,4,5};																						// array pour la definition des relais

int8_t				etat_cdm_portail	= 0	;																		// Etat de la commande portail 0:portail fermé 1:portail ouvert 2:fermeture en cours 3:ouverture en coure

int8_t				rel_open_portail			;																		// Numéro du relai pour ouverture du portail
int8_t				etat_rel_open			= 0	;																		// Stockage position du relai d'ouverture
int						tempo_open_portail		;																		// Définition de la tempo d'ouverture du portail
unsigned long	timer_open_portail	  ;																		// Stockage millis au moment de la commande pour la tempo d'ouverture
int8_t				ecl1_open_portail			;																		// Stockage de l'association de eclairage 1 avec ouverture portail
int8_t				ecl2_open_portail			;																		// Stockage de l'association de eclairage 2 avec ouverture portail


int8_t				rel_close_portail			;																		// Numéro du relai pour fermeture du portail
int8_t				etat_rel_close		= 0	;																		// Stockage position du relai de fermeture
int						tempo_close_portail		;																		// Définition de la tempo de fermeture du portail
unsigned long timer_close_portail		;																		// Stockage millis au moment de la commande pour la tempo de fermeture

int8_t				etat_cdm_ecl1	= 0			;																		// Etat de la commande eclairage 1

int8_t				rel_ecl1 = 3					;																		// Numéro du relai pour eclairage 1
int						tempo_ecl1						;																		// Définition de la tempo de eclairage 1
unsigned long timer_ecl1						;																		// Stockage millis au moment de la commande pour la tempo de eclairage 1

int8_t				etat_cdm_ecl2	= 0			;																		// Etat de la commande eclairage 2

int8_t				rel_ecl2 = 4					;																		// Numéro du relai pour eclairage 2
int						tempo_ecl2						;																		// Définition de la tempo de eclairage 2
unsigned long timer_ecl2						;																		// Stockage millis au moment de la commande pour la tempo de eclairage 2


/***	SETUP  ***/

void setup() {

/***	init des com  ***/
	COM_Debug.begin(9600);																								// Init de la com debug a 9600 bauds
	BTSerial.begin(38400);
	COM_Debug.println(F("Démmarrage du module ARDUI-PORTAIL V1.00\n\r"));

/***  verification des EEPROM  ***/
	COM_Debug.println(F("Vérification des memoires"));

	if(EEPROM.read(0) !=0){																								// Si l'adresse 0 n'est pas a 0 on remet la config par defaut (au premier demarrage arduino neuve elle est à 255
		EEPROM.write(0, 0);delay(10);																				// Config enregistré
		EEPROM.write(1, 1);delay(10);																				// Config relai d'ouverture portail
		EEPROM.write(2, 1);delay(10);																				// Config tempo d'ouverture portail
		EEPROM.write(3, 0);delay(10);																				// Config eclairage 1 sur ouverture portail
		EEPROM.write(4, 0);delay(10);																				// Config éclairage 2 sur ouverture portail
		EEPROM.write(5, 2);delay(10);																				// Config relai fermeture portail
		EEPROM.write(6, 1);delay(10);																				// Config tempo fermeture portail
		EEPROM.write(7, 1);delay(10);																				// Config tempo éclairage 1
		EEPROM.write(8, 1);delay(10);																				// Config tempo éclairage 2
		COM_Debug.println(F("Mise a zero de l'eeprom :OK"));
	}
	delay(100);

	if(EEPROM.read(0)==0){																								// Si l'adresse 0 est à 1 on charge la config qui est sauvgardé
		rel_open_portail 			= EEPROM.read(1);delay(10);
		tempo_open_portail		= EEPROM.read(2);delay(10);
		ecl1_open_portail			= EEPROM.read(3);delay(10);
		ecl2_open_portail			= EEPROM.read(4);delay(10);
		rel_close_portail			= EEPROM.read(5);delay(10);
		tempo_close_portail		= EEPROM.read(6);delay(10);
		tempo_ecl1						= EEPROM.read(7);delay(10);
		tempo_ecl2						= EEPROM.read(8);delay(10);
		COM_Debug.println(F("Chargement de la config : OK"));
	}
	delay(100);


/*** init des pin  ***/
	COM_Debug.print(F("Initialisation des relais : "));
	for(int i=1;i<=4;i++){																								// Init des pin de relais
		pinMode(rel[i], OUTPUT);
		delay(50);
	}
	COM_Debug.println(F("OK\n\r\n\rConfiguration actuelle\n\r"));

/***  Récapitulatif de la configuration  ***/

	COM_Debug.print(F("*** Ouverture portail *** \n\r\tRelai : "));
	COM_Debug.println(rel_open_portail);
	COM_Debug.print(F("\tTempo : "));
	COM_Debug.print(tempo[tempo_open_portail]);
	COM_Debug.print(F(" Seconde(s)\n\r\tEclairage 1 : "));
	COM_Debug.println(ecl1_open_portail);
	COM_Debug.print(F("\tEclairage 2 : "));
	COM_Debug.println(ecl1_open_portail);

	COM_Debug.print(F("\n\r*** Fermeture portail *** \n\r\tRelai : "));
	COM_Debug.println(rel_close_portail);
	COM_Debug.print(F("\tTempo : "));
	COM_Debug.print(tempo[tempo_close_portail]);
	COM_Debug.println(F(" Seconde(s)"));

	COM_Debug.print(F("\n\r*** Eclairage 1 *** \n\r\tRelai : "));
	COM_Debug.println(rel_ecl1);
	COM_Debug.print(F("\tTempo : "));
	COM_Debug.print(tempo[tempo_ecl1]);
	COM_Debug.println(F(" Seconde(s)"));

	COM_Debug.print(F("\n\r*** Eclairage 2 *** \n\r\tRelai : "));
	COM_Debug.println(rel_ecl2);
	COM_Debug.print(F("\tTempo : "));
	COM_Debug.print(tempo[tempo_ecl2]);
	COM_Debug.println(F(" Seconde(s)\n\r"));
	delay(500);																														// On attend un peu " On n'est pas des tirans quand même"

	COM_Debug.println(F("CONFIGURATION DE ARDUI-PORTAIL TERMINÉE"));
}

/*** LOOP   ***/

void loop() {

/***  Vérification des bytes sur BTSerial  ***/

	while(BTSerial.available()){
    BTSerial_Buffer[bit]=(BTSerial.read());															// On stocke la trame reçut
    bit++;
	}

/*** Vérification que la trame reçue est complete ***/

	if(BTSerial_Buffer[0] == 'S' && BTSerial_Buffer[bit-1] == 'E'){				// Si la trame est complete
		Action_recept(BTSerial_Buffer,bit);																	// On traite la trame
	}
		Action_tempo();																											// Fonction des action sur tempo
}

/***  Fonction  ***/

unsigned long second(){																									// fonction de retour de la timestamp en seconde
	return (millis()/1000);
}

void Action_recept(char* trame,int8_t nb_bit){
	bit = 0;
	COM_Debug.print(F("RCV : "));
	COM_Debug.println(BTSerial_Buffer);																		// Un petit debug toujours pratique
	if(nb_bit >=7){																												// si réception d'une trame de config
		if(trame[1] == 'C' && trame[2] == 'O' &&  trame[3] == 'N' && trame[4] == 'F' && trame[5] == 'I' &&  trame[6] == 'G'){// Si nouvelle connexion page config on envoi l'état de la config
			COM_Debug.println(F("Envoi des config par commande"));
			delay(750);

			BTSerial.print(F("S:1:1:"));
			BTSerial.print(tempo_open_portail);
			BTSerial.print(F(":"));
			BTSerial.print(rel_open_portail);
			BTSerial.print(F(":"));
			BTSerial.print(ecl1_open_portail);
			BTSerial.print(F(":"));
			BTSerial.print(ecl2_open_portail);
			BTSerial.print(F(":E"));
			delay(500);																												// On attend pour que android traite la trame vu qu'il verifie toute les 200 Milli-secondes

			BTSerial.print(F("S:1:2:"));
			BTSerial.print(tempo_close_portail);
			BTSerial.print(F(":"));
			BTSerial.print(rel_close_portail);
			BTSerial.print(F(":0:0:E"));
			delay(500);

			BTSerial.print(F("S:1:3:"));
			BTSerial.print(tempo_ecl1);
			BTSerial.print(F(":0:0:0:E"));
			delay(500);

			BTSerial.print(F("S:1:4:"));
			BTSerial.print(tempo_ecl2);
			BTSerial.print(F(":0:0:0:E"));
			delay(500);
		}
		else if(trame[2] == '1' && trame[1] == '1' ){Config_portail(trame,1);}// Réception d'une trame de config d'ouverture de portail
		else if(trame[2] == '2' && trame[1] == '1' ){Config_portail(trame,2);}// Réception d'une trame de config de fermeture de portail
		else if(trame[2] == '3' && trame[1] == '1' ){Config_ecl(trame,1);}	// Réception d'une trame de config d'éclairage 1
		else if(trame[2] == '4' && trame[1] == '1' ){Config_ecl(trame,2);}	// Réception d'une trame de config d'éclairage 2


	}
	else{
		if(trame[1] == 'C' && trame[2] == 'M' &&  trame[3] == 'D'){					// Si nouvelle connexion page commande on envoi l'état des commandes
			COM_Debug.println(F("Envoi des états des commandes"));
			delay(750);

			BTSerial.print(F("S:0:1:"));
			BTSerial.print(etat_cdm_portail);
			BTSerial.print(F(":E"));
			delay(200);																												// On attend pour que android traite la trame vu qu'il verifie toute les 100 Mili-seconde

			BTSerial.print(F("S:0:3:"));
			BTSerial.print(etat_cdm_ecl1);
			BTSerial.print(F(":E"));
			delay(200);

			BTSerial.print(F("S:0:4:"));
			BTSerial.print(etat_cdm_ecl2);
			BTSerial.print(F(":E"));
			delay(200);
		}
		else if(trame[1] == '0' && trame[2] == '1'){Action_portail();}			// Réception d'une trame de commande de portail
		else if(trame[1] == '0' && trame[2] == '3'){Action_ecl1(0);}				// Réception d'une trame de commande d'éclairage 1
		else if(trame[1] == '0' && trame[2] == '4'){Action_ecl2(0);}				// Réception d'une trame de commande d'éclairage 2

	}
	memset(BTSerial_Buffer,0,9); 																					// On vide le char BTSerial_Buffer
}

void Config_portail(char* trame,int8_t etat){
	if(etat == 1){																												// Config d'ouverture
		/*** on met à jour la config dans l'eeprom  ***/
		EEPROM.update(0,0);delay(10);																				// Delai de 10 Ms pour eviter les erreurs
		tempo_open_portail 	= trame[3]-48;
		EEPROM.update(2,tempo_open_portail);delay(10);
		rel_open_portail		= trame[4]-48;
		EEPROM.update(1,rel_open_portail);delay(10);
		ecl1_open_portail		= trame[5]-48;
		EEPROM.update(3,ecl1_open_portail);delay(10);
		ecl2_open_portail		= trame[6]-48;
		EEPROM.update(4,ecl2_open_portail);delay(10);
	}
	if(etat == 2){																												// Config de fermeture
		/*** on met à jour la config dans l'eeprom  ***/
		EEPROM.update(0,0);delay(10);
		tempo_close_portail 	= trame[3]-48;
		EEPROM.update(6,tempo_close_portail);delay(10);
		rel_close_portail		= trame[4]-48;
		EEPROM.update(5,rel_close_portail);delay(10);
	}
}

void Config_ecl(char* trame,int8_t etat){
	if(etat == 1){																												// Config d'eclaire 1
		/*** on met à jour la config dans l'eeprom  ***/
		EEPROM.update(0,0);delay(10);
		tempo_ecl1 	= trame[3]-48;
		EEPROM.update(7,tempo_ecl1);delay(10);

	}
	if(etat == 2){																												// Config d'eclaire 2
		/*** on met à jour la config dans l'eeprom  ***/
		EEPROM.update(0,0);delay(100);
		tempo_ecl2 	= trame[3]-48;
		EEPROM.update(8,tempo_ecl2);delay(100);
	}
}

void Action_portail(){
	etat_cdm_portail = 1 - etat_cdm_portail;															// On inverse l'état de la commande

			BTSerial.print(F("S:0:1:"));																					// On envoi la prise en compte
			BTSerial.print(etat_cdm_portail+2);																// +2 pour afficher la prise en compte sur android
			BTSerial.print(F(":E"));
			delay(200);
			if(etat_cdm_portail == 1){																				// Commande d'ouverture portail
				if(ecl1_open_portail == 1){Action_ecl1(1);}											// Si prise en compte eclairage 1 on envoi la commande
				if(ecl2_open_portail == 1){Action_ecl2(1);}											// Si prise en compte eclairage 2 on envoi la commande
				if(etat_rel_open == 0){
					digitalWrite(rel[rel_close_portail],LOW);											// On change l'état du relais	de fermeture pour eviter les double commande
					etat_rel_close = 0;
					delay(250);
					digitalWrite(rel[rel_open_portail],HIGH);											// On change l'état du relais	d'ouverture
					etat_rel_open = 1;

					if(tempo_open_portail >= 2){																	// S'il y a une tempo d'ouverture on enregistre la timestamp
						timer_open_portail = second()+tempo[tempo_open_portail];
					}
					else{																													// Sinon on envoi l'état de la commande
						BTSerial.print(F("S:0:1:"));
						BTSerial.print(etat_cdm_portail);
						BTSerial.print(F(":E"));
						delay(200);
					}
				}
			}
			else if(etat_cdm_portail == 0 && etat_rel_close == 0){						// Commande de fermeture de portail
				digitalWrite(rel[rel_open_portail],LOW);												// On change l'état du relais	d'ouverture pour eviter les double commande
				etat_rel_open = 0;
				delay(250);
				digitalWrite(rel[rel_close_portail],HIGH);											// On change l'état du relais	de fermeture
				etat_rel_close = 1;

				if(tempo_close_portail >= 2){																		// S'il y a une tempo de fermeture on enregistre la timestamp
					timer_close_portail = second()+tempo[tempo_close_portail];
				}
				else{																														// Sinon on envoi l'état de la commande
					BTSerial.print(F("S:0:1:"));
					BTSerial.print(etat_cdm_portail);
					BTSerial.print(F(":E"));
					delay(200);
				}
			}
}

void Action_ecl1(int8_t etat){
	if(etat == 1){																												// Si etat a 1 on force la prise de commande
		etat_cdm_ecl1 = 1;
	}
	else{																																	// Sinon on inverse l'état
		etat_cdm_ecl1 = 1 - etat_cdm_ecl1;
	}

	BTSerial.print(F("S:0:3:"));																					// On envoi la prise en compte
	BTSerial.print(etat_cdm_ecl1);
	BTSerial.print(F(":E"));
	delay(200);

	if(tempo_ecl1 >= 2 && etat_cdm_ecl1 == 1){														// S'il y a une tempo on enregistre la timestamp
		timer_ecl1 = second()+tempo[tempo_ecl1];
	}
	digitalWrite(rel[rel_ecl1],etat_cdm_ecl1);														// On change l'état du relais
}

void Action_ecl2(int8_t etat){
	if(etat == 1){																												// Si etat a 1 on force la prise de commande
		etat_cdm_ecl2 = 1;
	}
	else{																																	// Sinon on inverse l'état
		etat_cdm_ecl2 = 1 - etat_cdm_ecl2;
	}

	BTSerial.print(F("S:0:4:"));																					// On envoi la prise en compte
	BTSerial.print(etat_cdm_ecl2);
	BTSerial.print(F(":E"));
	delay(200);

	if(tempo_ecl2 >= 2 && etat_cdm_ecl2 == 1){														// S'il y a une tempo on enregistre la timestamp
		timer_ecl2 = second()+tempo[tempo_ecl2];
	}
	digitalWrite(rel[rel_ecl2],etat_cdm_ecl2);														// On change l'état du relais
}

void Action_tempo(){
	// si millis est plus grand que la tempo d'ouverture et relai etat haut et tempo active (sinon permanent)
	if(second() >= timer_open_portail && etat_rel_open == 1 && tempo_open_portail >= 2 ){
			etat_cdm_portail = 1;																							// On inverse l'état
			BTSerial.print(F("S:0:1:"));																			// On envoi la prise en compte
			BTSerial.print(etat_cdm_portail);
			BTSerial.print(F(":E"));
			digitalWrite(rel[rel_open_portail],LOW);													// On change l'état du relai d'ouverture
			etat_rel_open = 0 ;
			delay(200);

	}
	// si millis est plus grand que la tempo de fermeture et relai etat haut et tempo active (sinon permanent)
	if(second() >= timer_close_portail && etat_rel_close == 1 && tempo_close_portail >= 2 ){
			etat_cdm_portail = 0;																							// On inverse l'état
			BTSerial.print(F("S:0:1:"));																			// On envoi la prise en compte
			BTSerial.print(etat_cdm_portail);
			BTSerial.print(F(":E"));
			digitalWrite(rel[rel_close_portail],LOW);													// On change l'état du relai de fermeture
			etat_rel_close = 0 ;
			delay(200);
		}
	// si millis est plus grand que la tempo d'éclairage 1  et relai etat haut et tempo active (sinon permanent)
	if(second() >= timer_ecl1 && etat_cdm_ecl1 == 1 && tempo_ecl1 >= 2 ){
			etat_cdm_ecl1 = 0;																								// On inverse l'état
			BTSerial.print(F("S:0:3:"));																			// On envoi la prise en compte
			BTSerial.print(etat_cdm_ecl1);
			BTSerial.print(F(":E"));
			digitalWrite(rel[rel_ecl1],etat_cdm_ecl1);												// On change l'état du relai d'éclairage 1
			delay(200);
		}
	// si millis est plus grand que la tempo d'éclairage 2 et relai etat haut et tempo active (sinon permanent)
	if(second() >= timer_ecl2 && etat_cdm_ecl2 == 1 && tempo_ecl2 >= 2 ){
			etat_cdm_ecl2 = 0;																								// On inverse l'état
			BTSerial.print(F("S:0:4:"));																			// On envoi la prise en compte
			BTSerial.print(etat_cdm_ecl2);
			BTSerial.print(F(":E"));
			digitalWrite(rel[rel_ecl2],etat_cdm_ecl2);												// On change l'état du relai d'éclairage 1
			delay(200);
		}
}
